*---        InitFormul()
procedure InitFormul
public MAXSTACK
MAXSTACK = 50
public resul[MAXSTACK],opera[MAXSTACK],state[MAXSTACK]
public stacktop
stacktop = 0
public TokenError
return
*---        Pushf()
procedure Pushf
if stacktop = MAXSTACK
  TokenError = .T.
else
  stacktop = stacktop + 1
  resul[stacktop] = curresul
  opera[stacktop] = curopera
  state[stacktop] = curstate
endif
return
*---        Popf()
procedure Popf
  curresul = resul[stacktop]
  curopera = opera[stacktop]
  curstate = state[stacktop]
  stacktop = stacktop - 1
return
*---        Formula(formula)
function Formula
parameters formula
private curtoken,curtypet,curvalue,curresul,curopera,curstate,curcells
LoadFormul(formula)
curtypet = 1
TokenError = .F.
do while .not.TokenError.and.curtypet!=0
 curresul = 0
 curopera = 1                && PLUS
 curstate = 0                && EOL
 curcells=NextCells()
 if empty(curcells)
  curvalue = Parse()
 else
  &curcells. = Parse()
 endif
enddo
if TokenError
  ParseError()
  curvalue = 0
endif
return curvalue
*---        Parse()
function Parse
do while (.not.TokenError)
  curtoken=NextToken()
  curtypet=NextTypet()
  do case
    case curtypet = 10                && CELL
      if type("&curtoken") = "N"
        curvalue = &curtoken
      else
        TokenError = .T.
        exit
      endif
    case curtypet = 9                && NUM
      curvalue = val(curtoken)
    case curtypet = 5                && OPAREN
      Pushf()
      curresul = 0
      curopera = 1        && PLUS
      curstate = 7        && CPAREN
      curvalue = Parse()
      Popf()
    case curtypet = 11                && FUN
      Pushf()
      curresul = 0
      curopera = 1        && PLUS
      curstate = 7        && CPAREN
      do case
        case curtoken = "INT("
          curvalue = int(Parse())
        case curtoken = "INR("
          curvalue = int(Parse()+0.5)
        case curtoken = "ABS("
          curvalue = abs(Parse())
        case curtoken = "EXP("
          curvalue = exp(Parse())
        case curtoken = "LOG("
          curvalue = Parse()
          if curvalue > 0
            curvalue = log(curvalue)
          else
            TokenError = .T.
            exit
          endif
        case curtoken = "SQRT("
          curvalue = Parse()
          if curvalue >= 0
            curvalue = sqrt(curvalue)
          else
            TokenError = .T.
            exit
          endif
        case curtoken = "SQR("
          curvalue = Parse()
          curvalue = curvalue * curvalue
      endcase
      Popf()
    case curtypet = 12                && IIF
      Pushf()
      curresul = 0
      curopera = 1        && PLUS
      curstate = 6        && COMMA
      if Parse() <= 0
        curresul = 0
        curopera = 1        && PLUS
        curstate = 6        && COMMA
        curvalue = Parse()
        if .not.TokenError
          TokenError = NextParen()
        endif
      else
        if .not.TokenError
          TokenError = NextComma()
        endif
        curresul = 0
        curopera = 1        && PLUS
        curstate = 7        && CPAREN
        curvalue = Parse()
      endif
      Popf()
    case curtypet = 14                && CASE
      Pushf()
      curresul = 0
      curopera = 1        && PLUS
      curstate = 6        && COMMA
      if Parse() = 0
        curresul = 0
        curopera = 1        && PLUS
        curstate = 6        && COMMA
        curvalue = Parse()
        if .not.TokenError
          TokenError = NextParen()
        endif
      else
        if .not.TokenError
          TokenError = NextComma()
        endif
        curresul = 0
        curopera = 1        && PLUS
        curstate = 7        && CPAREN
        curvalue = Parse()
      endif
      Popf()
    othe
      TokenError = .T.
      exit
  endcase
  curtoken=NextToken()
  curtypet=NextTypet()
  do case                && pp  pp
    case (curtypet=3.or.curtypet=4).and.(curopera=1.or.curopera=2)
      Pushf()
      curresul = curvalue
      curopera = curtypet
      curstate = 1        && PLUSorMINUS
      curvalue = Parse()
      Popf()
    case curtypet=8        && EXPO
      if curvalue > 0
        Pushf()
        curresul = curvalue
        Pushf()
        curresul = 0
        curopera = 1        && PLUS
        curstate = 8        && EXPO
        curvalue = Parse()
        Popf()
        curvalue = exp(log(curresul) * curvalue)
        Popf()
      else
        TokenError = .T.
        exit
      endif
  endcase
  do case                && p䬥⨪
    case curopera = 1                && PLUS
      curresul = curresul + curvalue
    case curopera = 2                && MINUS
      curresul = curresul - curvalue
    case curopera = 3                && TIMES
      curresul = curresul * curvalue
    case curopera = 4                && DIVIDE
      if curvalue != 0
        curresul = curresul / curvalue
      else
        TokenError = .T.
        exit
      endif
  endcase
  curopera = curtypet
  do case                && ᫥-. case !
    case curtypet = 7                        && CPAREN
      if curstate != 7.and.curstate != 1.and.curstate != 8
        TokenError = .T.
      endif
      exit
    case curtypet = 6                        && COMMA
      if curstate != 6.and.curstate != 1.and.curstate != 8
        TokenError = .T.
      endif
      exit
    case curtypet = 0                        && EOL
      if curstate != 0.and.curstate != 1.and.curstate != 8
        TokenError = .T.
      endif
      exit
    case curtypet = 15                        && SEMIC
      if curstate != 0.and.curstate != 1.and.curstate != 8
        TokenError = .T.
      endif
      exit
    case curtypet = 1.or.curtypet = 2        && PLUSorMINUS
      if curstate = 1.or.curstate = 8
        exit
      endif
    case curtypet = 3.or.curtypet = 4        && TIMESorDIVIDE
      if curstate = 8
        exit
      endif
    case curtypet = 13                        && BAD
      TokenError = .T.
      exit
  endcase
enddo
return curresul
*---        ParseError()
procedure ParseError
private old_color,ch
old_color = setcolor(cw)
save screen
BoxTenj(Y_srm-2,X_srm-37,Y_srm+2,X_srm+37,ibox)
set color to &cl
@ Y_srm-2,X_srm-8 say "       !!! "
setcolor(cw)
@ Y_srm-1,X_srm-18 say "p  p  樨 - "+ltrim(str(PosError()))
@   Y_srm,X_srm-36 say substr(formula,1,72)
@ Y_srm+1,X_srm+iif(PosError()<=72,PosError(),72)-37 say "^"
ch=inkey(0)
restore screen
setcolor(old_color)
return
